<html>
<head>
<title>OgreGLSLESProgramCommon.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_740c5ae02f3e58539fc77518d7d26661.html">GLES2</a>      </li>
      <li class="navelem"><a class="el" href="dir_869fcd4d0767bf0c6544e0566078ca07.html">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_9c8668f5b14e7779923b4ed363e11a4e.html">GLSLES</a>      </li>
      <li class="navelem"><a class="el" href="dir_84d626bd39fc7a71e1d66527f3ce1f64.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLSLESProgramCommon.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLSLESProgramCommon_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> -----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment"> This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment"> (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment"> For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"> </span>
<a name="l00007"></a>00007 <span class="comment"> Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"> </span>
<a name="l00009"></a>00009 <span class="comment"> Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment"> of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment"> in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment"> to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment"> copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment"> furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"> </span>
<a name="l00016"></a>00016 <span class="comment"> The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment"> all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"> </span>
<a name="l00019"></a>00019 <span class="comment"> THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment"> IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment"> FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment"> AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment"> LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment"> OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment"> THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment"> -----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __GLSLESProgramCommon_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __GLSLESProgramCommon_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLES2Prerequisites_8h.html">OgreGLES2Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037     <span class="keyword">class </span>GLSLESGpuProgram;
<a name="l00038"></a>00038 
<a name="l00040"></a>00040     <span class="keyword">struct </span>GLUniformReference
<a name="l00041"></a>00041     {
<a name="l00043"></a>00043         GLint <a class="code" href="structOgre_1_1GLUniformReference.html#a40c3bd9bb06deeb80a6f3797649a5335" title="GL location handle.">mLocation</a>;
<a name="l00045"></a>00045         <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> <a class="code" href="structOgre_1_1GLUniformReference.html#a2d32db8791ed30e82ae3a73485ab0085" title="Which type of program params will this value come from?">mSourceProgType</a>;
<a name="l00047"></a>00047         <span class="keyword">const</span> GpuConstantDefinition* <a class="code" href="structOgre_1_1GLUniformReference.html#af895033109bbba669cdaa19710aca90b" title="The constant definition it relates to.">mConstantDef</a>;
<a name="l00048"></a>00048     };
<a name="l00049"></a>00049 
<a name="l00050"></a>00050     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;GLUniformReference&gt;::type</a> <a class="code" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a>;
<a name="l00051"></a>00051     <span class="keyword">typedef</span> GLUniformReferenceList::iterator <a class="code" href="namespaceOgre.html#a644f74bf84779c83312a97e169164d07">GLUniformReferenceIterator</a>;
<a name="l00052"></a>00052 
<a name="l00057"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgreGLES2Prerequisites_8h.html#a3f2e060c56216a4f3fb7650e502f5735">_OgreGLES2Export</a> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html" title="C++ encapsulation of GLSL ES Program Object.">GLSLESProgramCommon</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">protected</span>:
<a name="l00061"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#afb171f98bf9599ea856e1864e26de6ea">00061</a>         <a class="code" href="namespaceOgre.html#a24aca8d208dcf62fbe3bee9e759ac73d">GLUniformReferenceList</a> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#afb171f98bf9599ea856e1864e26de6ea" title="Container of uniform references that are active in the program object.">mGLUniformReferences</a>;
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#ac5cf7946fde74b57c5fceb2c24a6d60a">00064</a>         <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#ac5cf7946fde74b57c5fceb2c24a6d60a" title="Linked vertex program.">mVertexProgram</a>;
<a name="l00066"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#aef417ccb07b8bad6b898ac41f54c289e">00066</a>         <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#aef417ccb07b8bad6b898ac41f54c289e" title="Linked fragment program.">mFragmentProgram</a>;
<a name="l00068"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a47b1e5061bc550867335014ba3188c89">00068</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a47b1e5061bc550867335014ba3188c89" title="Flag to indicate that uniform references have already been built.">mUniformRefsBuilt</a>;
<a name="l00070"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a32fa510f466594b7bd69de3af522f793">00070</a>         GLuint <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a32fa510f466594b7bd69de3af522f793" title="GL handle for the program object.">mGLProgramHandle</a>;
<a name="l00072"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#aa4613eadde3f6f512a89e991888ccf04">00072</a>         GLint <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#aa4613eadde3f6f512a89e991888ccf04" title="Flag indicating that the program or pipeline object has been successfully linked.">mLinked</a>;
<a name="l00074"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a2e72c24016de1d9a5a361cc415094a56">00074</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a2e72c24016de1d9a5a361cc415094a56" title="Flag indicating that the program or pipeline object has tried to link and failed.">mTriedToLinkAndFailed</a>;
<a name="l00076"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a4f7674420fd6fd2003a8d38260b2dd4e">00076</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a4f7674420fd6fd2003a8d38260b2dd4e" title="Flag indicating skeletal animation is being performed.">mSkeletalAnimation</a>;
<a name="l00077"></a>00077 
<a name="l00079"></a>00079         <span class="keywordtype">void</span> buildGLUniformReferences(<span class="keywordtype">void</span>);
<a name="l00080"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a6089666bc8be948f5ebecfd598d08d05">00080</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;GLuint&gt;::type</a> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a6089666bc8be948f5ebecfd598d08d05">AttributeSet</a>;
<a name="l00081"></a>00081 
<a name="l00083"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#afefa1d74fe3ba0d79068e0fae9dd3392">00083</a>         GLint mCustomAttributesIndexes[<a class="code" href="group__RenderSystem.html#gga0a62b3f2ede8992ff365bb013a8bc00da6f167783a26ed5d1c146fbeae995af0b" title="The number of VertexElementSemantic elements (note - the first value VES_POSITION is 1)...">VES_COUNT</a>][<a class="code" href="OgreConfig_8h.html#a73f03c4000193e826a1489b02ea50309" title="If set to 1, Real is typedef&#39;ed to double.">OGRE_MAX_TEXTURE_COORD_SETS</a>];
<a name="l00085"></a><a class="code" href="OgreGLSLESProgramCommon_8h.html#a80dc964d0705d8b2bf1c06874b523c65">00085</a> <span class="preprocessor">#define NULL_CUSTOM_ATTRIBUTES_INDEX -2</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00087"></a><a class="code" href="OgreGLSLESProgramCommon_8h.html#afbaa9874550eb36340280f38ae146c22">00087</a> <span class="preprocessor">#define NOT_FOUND_CUSTOM_ATTRIBUTES_INDEX -1</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>
<a name="l00089"></a>00089         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a> getCombinedName(<span class="keywordtype">void</span>);
<a name="l00091"></a>00091         <span class="keywordtype">void</span> getMicrocodeFromCache(<span class="keywordtype">void</span>);
<a name="l00093"></a>00093         <span class="keyword">virtual</span> <span class="keywordtype">void</span> compileAndLink(<span class="keywordtype">void</span>) = 0;
<a name="l00095"></a>00095         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _useProgram(<span class="keywordtype">void</span>) = 0;
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#afd8df837c19c089dd8d3de4d79195dba">00097</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, VertexElementSemantic&gt;::type</a> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#afd8df837c19c089dd8d3de4d79195dba">SemanticToStringMap</a>;
<a name="l00098"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#ae517ad6821a32dc8ad80bbae8bc12d71">00098</a>         <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#afd8df837c19c089dd8d3de4d79195dba">SemanticToStringMap</a> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#ae517ad6821a32dc8ad80bbae8bc12d71">mSemanticTypeMap</a>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> getAttributeSemanticEnum(<a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> type);
<a name="l00101"></a>00101         <span class="keyword">const</span> <span class="keywordtype">char</span> * getAttributeSemanticString(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     <span class="keyword">public</span>:
<a name="l00105"></a>00105         <a class="code" href="classOgre_1_1GLSLESProgramCommon.html" title="C++ encapsulation of GLSL ES Program Object.">GLSLESProgramCommon</a>(<a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* vertexProgram, <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* fragmentProgram);
<a name="l00106"></a>00106         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLSLESProgramCommon.html" title="C++ encapsulation of GLSL ES Program Object.">GLSLESProgramCommon</a>(<span class="keywordtype">void</span>);
<a name="l00107"></a>00107 
<a name="l00110"></a>00110         <span class="keyword">virtual</span> <span class="keywordtype">void</span> activate(<span class="keywordtype">void</span>) = 0;
<a name="l00111"></a>00111 
<a name="l00115"></a>00115         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updateUniforms(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> mask, <a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> fromProgType) = 0;
<a name="l00119"></a>00119         <span class="keyword">virtual</span> <span class="keywordtype">void</span> updatePassIterationUniforms(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params) = 0;
<a name="l00121"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#af0d73a3352f3d0d396fa5ced1cb7c79e">00121</a>         GLuint <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#af0d73a3352f3d0d396fa5ced1cb7c79e" title="Get the GL Handle for the program object.">getGLProgramHandle</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGLProgramHandle; }
<a name="l00128"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a67993567b5302107ef1730147aa4071b">00128</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a67993567b5302107ef1730147aa4071b" title="Sets whether the linked program includes the required instructions to perform skeletal animation...">setSkeletalAnimationIncluded</a>(<span class="keywordtype">bool</span> included) { mSkeletalAnimation = included; }
<a name="l00129"></a>00129 
<a name="l00136"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a8cf3062bfbf1c8a7ba0c2ff3350cbfae">00136</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a8cf3062bfbf1c8a7ba0c2ff3350cbfae" title="Returns whether the linked program includes the required instructions to perform skeletal animation...">isSkeletalAnimationIncluded</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSkeletalAnimation; }
<a name="l00137"></a>00137 
<a name="l00139"></a>00139         <span class="keyword">virtual</span> GLint getAttributeIndex(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00141"></a>00141         <span class="keywordtype">bool</span> isAttributeValid(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> index);
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a5d44237c5eb6e0d27f26c4ddae941992">00143</a>         <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a5d44237c5eb6e0d27f26c4ddae941992">getVertexProgram</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVertexProgram; }
<a name="l00144"></a><a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a02bc60d115a5ca95f53573aaf0c4dc81">00144</a>         <a class="code" href="classOgre_1_1GLSLESGpuProgram.html" title="GLSL ES low level compiled shader object - this class is used to get at the linked program object and...">GLSLESGpuProgram</a>* <a class="code" href="classOgre_1_1GLSLESProgramCommon.html#a02bc60d115a5ca95f53573aaf0c4dc81">getFragmentProgram</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFragmentProgram; }
<a name="l00145"></a>00145     };
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="preprocessor">#endif // __GLSLESProgramCommon_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
